; **********************************************************************
; ***** Routinen zum Ansteuern des Displays ****************************
; ***** Initalisieren des Displays 			
; ***** 					Init_Display
; ***** UND
; ***** Daten oder Code an Display senden	
; ***** 					Disp_Send_Data
; *****						Disp_Send_Code
; ***** UND
; ***** Positionieren des Cursors (anpassen bei anderen Displaytypen)
; *****						LocateZ_S
; ***** UND
; ***** Text lesen aus Speicher und Ausgeben	
; *****						Text_Eeprom_To_Disp

; ********************************************************************
; ***** Display initalisieren ****************************************
; ***** s. Datenblatt zum Display ************************************
; ***** -- Register **************************************************
; ***** zu allg. arbeiten 		: 	WORK ( ab r16) *******
; ***** PAUSE lnge			:	PAUSEWERT ( ab r16) **
; ***** bergabe eine Wertes an Display	:	DATEN_DAT ( ab r16) **
; ***** -- Variblen **************************************************
; ***** Display auf Empfang setzen	:	DDR_WRITE_DISPLAY ****
; *****	setzen der Modi s. Datenblatt,  :	DISPLAY_FUNK_SET *****
; *****	werte vordef. am Anfang des 	:	DISPLAY_DISP *********
; *****	programmes			:	DISPLAY_CLEAR ********
; *****					:	DISPLAY_EMODE ********
; ***** -- Ports *****************************************************
; ***** PortB -DDR			:	PORTB_DDR ************
; ***** PortB -Daten			:       PORTB_D **************
; ***** -- Routinen **************************************************
; ***** den E-Puls senden		:	Send_E_Puls **********
; ***** Pause				:	Delay_X **************
; ********************************************************************
Init_Display:
	ldi 	WORK,DDR_WRITE_DISPLAY	; Portrichtung zum schreiben auf display
	out 	PORTB_DDR,WORK
	;*** ab hier siehe datenblatt
	ldi 	PAUSEWERT, 170		; 170 x ca. 100us = ca. 17ms
	rcall 	Delay_X			; Pause mind. 15ms
	;* ERSTE (4bit) sequ. laut datenblatt
	ldi 	WORK, 0b000011		
	out 	PORTB_D, WORK 		
	rcall 	Send_E_Puls		; mit E_PULS datenbernahme
	ldi 	PAUSEWERT, 50		; 5ms
	rcall 	Delay_X			; und eine Pause mind. 4ms
	;* ZWEITE
	; da Ports schon gesetzt kann auf nochmal. setzen verzichtet werden
	; und einfach mit den Pausen und E_pulsen fortgefahren werden
	rcall 	Send_E_Puls		; E_PULS datenbernahme
	ldi 	PAUSEWERT, 20		; 2ms
	rcall 	Delay_X			; und eine Pause 
	;* DRITTE sequ. laut datenblatt 		
	rcall 	Send_E_Puls		; E_PULS datenbernahme
	ldi 	PAUSEWERT, 20		; zwar nicht angeb. aber ntig ! 
	rcall 	Delay_X			; und eine Pause 
	;* VIERTE sequ. laut datenblatt
	cbi 	PORTB_D,0		; einfach bit 0 lschen
	rcall 	Send_E_Puls		; E_PULS datenbernahme
	ldi 	PAUSEWERT, 20		; w.o.
	rcall 	Delay_X			; und eine Pause 
	;** ab hier ist auf 4bit umgeschalten !!! und es mu dem Display mitgeteilt
	;* werden das Code kommt !!!			
	;** funktions-set
	ldi 	DISPLAY_DAT, DISPLAY_FUNK_SET
	rcall	Disp_Send_Code		; routine zum CODE an Displ. zu senden
	;** display an
	ldi 	DISPLAY_DAT,DISPLAY_DISP
	rcall 	Disp_Send_Code
	;** Clear Display
	ldi 	DISPLAY_DAT,DISPLAY_CLEAR 
	rcall 	Disp_Send_Code
	;** Entry-Mode-Set
	ldi 	DISPLAY_DAT,DISPLAY_EMODE 
	rcall 	Disp_Send_Code
	; DD-RAM auf NULL 	
	ldi	DISPLAY_DAT,DISPLAY_DDRAM_NULL
	rcall	Disp_Send_Code
	ret	
; *** End Display initalisieren **************************************	

; *********************************************************************
; ***** Sende Commando oder Daten an das Display **********************
; ***** -- Register ***************************************************
; ***** bergabe des Wertes		:	DISPLAY_DAT ***********
; ***** zwischenspeicher		:	TEMP_DISP *************
; ***** Verknpfung ent Dat/Code	:	TEMP_DISP_DS **********
; ***** PAUSE lnge			:	PAUSEWERT *************
; ***** zu and. arbeiten 		: 	WORK ******************
; ***** -- Variblen ***************************************************
; ***** Display auf Empfang setzen	:	DDR_WRITE_DISPLAY *****
; ***** -- Ports ******************************************************
; ***** PortB -DDR			:	PORTB_DDR *************
; ***** PortB -Daten			:       PORTB_D ***************
; ***** -- Routinen ***************************************************
; ***** den E-Puls senden		:	Send_E_Puls ***********
; ***** Pause				:	Delay_X ***************
; *********************************************************************
; *** fr Datensenden mu R/S H
Disp_Send_Data:
	ldi     TEMP_DISP_DS,16		; R/S auf H fr Daten (f. spt. or)
	rjmp	Disp_Send
; *** fr Codesenden mu R/S L		
Disp_Send_Code: 
	clr     TEMP_DISP_DS		; R/S auf L fr Code
; *** Sende Daten
Disp_Send:
	push	WORK

	ldi	WORK,UART_CR_OFF	; UART - Einstellen das kein Int 
	out	UART_UCSRB,WORK		; beim auslesen ausgelst wird
	; das Display-Busy abfragen ob Display bereit
	ldi	TEMP_DISP, DDR_READ_DISPLAY  	; lesen von Display einstellen
	out	PORTB_DDR, TEMP_DISP
	ldi	TEMP_DISP, 0b101111		; Code lesen v. Display u. EingangsPull-up an
	out	PORTB_D, TEMP_DISP
	Disp_Busy_Wait:
	 sbi	PORTC_D, 0		; E auf High
	 nop				; warte kurz bis Display Daten sendet
	 nop
	 nop
	 in	TEMP_DISP, PINB		; und einlesen
	 cbi	PORTC_D, 0		; E auf Low
	 nop
	 nop
	 rcall  Send_E_Puls		; unteren 4Bits lesen (werden aber nicht bentigt)
	 bst    TEMP_DISP, 3   		; Busyflag bit nach T schieben
	 brtc   Disp_Ready		; T=0 ? dann Display bereit f. nchste Daten
	 nop				; sonst warte noch mind. 1S
	 nop
	 nop
	 nop
	 nop
	 rjmp	Disp_Busy_Wait	 	     			
	Disp_Ready:			; Weiter da Display Brereit
	
	ldi 	WORK,DDR_WRITE_DISPLAY	; Portrichtung zum schreiben auf display
	out 	PORTB_DDR,WORK
	cbi	PORTB_D,5		; R/W auf L damit Displ. auf Empfang geht 
	; denn 8bit-WErt in 2x4bit  Wert umwandeln um senden
	mov 	TEMP_DISP, DISPLAY_DAT  ; sichere bergeb. Wert
	swap 	DISPLAY_DAT		; tausche Nibbles, damit obere hlfte zuerst gesendet
	andi	DISPLAY_DAT,0x0f	; lsche obere Hlfte
	or 	DISPLAY_DAT,TEMP_DISP_DS ; und setze wieder R/S
	out 	PORTB_D,DISPLAY_DAT	; ausgeben an Ports
	rcall 	Send_E_Puls		; und Displ. bernimmt Daten durch E-Impuls 
	andi	TEMP_DISP,0x0f		; jetzt noch den LOW-Teil der ja im gesicht. TEMP steht
	or 	TEMP_DISP,TEMP_DISP_DS	; R/S wieder setzen
	out 	PORTB_D,TEMP_DISP	; ...
	rcall 	Send_E_Puls		; ...	
	ldi	WORK,UART_CR		; UART - wieder an
	out	UART_UCSRB,WORK		; 
	
	pop	WORK
	ret
;*** End Daten/Code senden *******************************************	

	
; ********************************************************************	
; ***** sende E-Puls damit Displ. Daten bernimmt ********************
; ***** -- Ports *****************************************************
; ***** PortC -DDR			:	PORTC_DDR ************
; ***** PortC -Daten			:       PORTC_D **************
; ********************************************************************
Send_E_Puls:
	sbi	PORTC_D,0		; E auf HIGH
	nop				; ...
	nop				; kurz E halten
	nop				; ...
	cbi	PORTC_D,0		; und E wieder LOW
	ret
; *** End E-Puls senden **********************************************



; *********************************************************************
; ***** setzt DD-RAM ADRESSE auf angegeb. Position ********************
; ***** locate Zeile, Spalte als HEX_ZAHL *****************************
; ***** Codierung : Bit 7/6 dient hier als Zeilenmarker, Bit 0-5  *****
; *****             als eigentliche Positionsangabe, d.h :        *****
; *****                                                           *****
; ***** Bit     7  6  5  4  3  2  1  0                            ***** 
; ***** Zeile   x  x                    0-3 , 0,64,128,192        *****
; ***** Spalten       x  x  x  x  x  x  0-63, 0 - 0x3F            *****
; *****                                                           ***** 
; ***** Zeile + Spalte = bergabeWert                             ***** 
; ***** Z1(64) + S5(5) = 69d, -> 0x45                             ***** 
; *****                                                           ***** 
; ***** es erfolgt KEINE FEHLERAUSWERTUNG !!!!!                   *****
; *****                                                           ***** 
; ***** -- Register ***************************************************
; ***** bergabe des Wertes	  :	DISPLAY_DAT *( ab r16)    *****
; ***** zwischenspeicher	  : 	TEMP *(ab r16)            *****
; *****                                 in Stack gesichert !      *****
; ***** -- Routinen ***************************************************
; ***** DD-RAM ADresse an Display :	Disp_Send_Code            *****
; *********************************************************************
LocateZ_S:
	
	push	DISPLAY_DAT		 ; rette
	mov	C_MERK,DISPLAY_DAT	 ; setze Merkposition
	tst	DISPLAY_DAT		 ; ZP -Zeile,Spalte hex
	breq	loc			 ; Zeile,Spalte ist Null dann direkt zum Ende		
	push	TEMP			 ; retten damit nur ein REG belegt
	mov	TEMP,DISPLAY_DAT	 ; rette Wert	
	; verschiebe ZeilenPosition von Bit7/8 uf Bit 0/1
	swap	DISPLAY_DAT		 ; Zeile in untere Bits..
	lsr     DISPLAY_DAT              ; 
	lsr     DISPLAY_DAT              ; ist verschoben
	andi 	DISPLAY_DAT,0b00000011 ; Zeile rausfiltern (Spalten. lschen)
	breq	loc_S			 ; Z=0 ?                  Zeile = 0
	dec	DISPLAY_DAT		 ; -1 Z1
	breq	loc_Z1			 ; ist es Null ? dann war Zeile = 1
	dec	DISPLAY_DAT		 ; -1 Z2
	breq	loc_Z2			 ; ist es Null ? dann war Zeile = 2
        ; Zeilenstart     , hier Zeile = 3
    	ldi	DISPLAY_DAT, DISPLAY_LINE_DREI
    	rjmp	loc_S
    loc_Z2:
	; Zeilenstart     , hier Zeile = 2
    	ldi	DISPLAY_DAT,DISPLAY_LINE_ZWEI 
    	rjmp	loc_S
    loc_Z1:
        ; Zeilenstart     , hier Zeile = 1
    	ldi	DISPLAY_DAT, DISPLAY_LINE_EINS
    loc_S:   				; und SPalte addieren
       	andi 	TEMP,0b00111111	 	; Spalte rausfiltern (Zeile. lschen)
    	add	DISPLAY_DAT, TEMP 	; dann addieren
	pop 	TEMP			; Wiederherstellen
    loc:
    	ori	DISPLAY_DAT,DISPLAY_DDRAM_NULL	; und Basis dazu
	rcall	Disp_Send_Code		;  ergibt DDRAM-ADresse
	pop	DISPLAY_DAT
	
	ret
; *** end LocateZ_S ***************************************************	




; ********************************************************************************
; *** String aus dem EEPROM dirket auf das Display ausgeben     **********
; *** bergabe der Stringdresse nach WORK2 !                    **********
; *** 								**********
; *** Stopzeichen am Stringende wird bentigt - NullByte !!!!   **********

Text_Eeprom_To_Disp:
	push	DISPLAY_DAT 	; test
	text_eeprom:
 	out 	EEADRESS,  WORK2	   ; setze EEPROM-Adresse auf Adresse
	sbi	EECONTR, 0		   ; setze das Daten gelsene werden sollen
	in	DISPLAY_DAT, EEDAT	   ; und schiebe die Daten nach DISPLAY_DAT
	tst	DISPLAY_DAT		   ; Stopzeichen ? 
	breq	text_eeprom_end		   ; ja dann ende sonst nchstes Zeichen
	rcall	Disp_Send_Data
	inc 	WORK2
	rjmp	text_eeprom
	text_eeprom_end:
	pop	DISPLAY_DAT 	; test
	ret
; *** End *********************************************


; *** Textstelle aus dem Programspeicher ausgeben *****
; *** bergabe der Textandresse nach Z ! **********
; *** DISPLAY_DAT wird auch bentigt ******************
; *** ACHTUNG .. ASC > 127 gibt probleme
Text_progm_To_Disp:
	push	DISPLAY_DAT
	text_progm:	 
	 lpm
	 tst	MEMORY			  
	 breq	text_progm_end		  
	 mov	DISPLAY_DAT, MEMORY
	 rcall	Disp_Send_Data
	 ld	MEMORY, Z+
	 rjmp	text_progm
	text_progm_end:
	pop	DISPLAY_DAT
	ret
; *** End *********************************************



