; *****************************************************************************
; ****** oft bentigte reine Speicherzugriffe...
; ****** Schreiben ins EEPROM:			Eeprom_Write
; ****** Prfsummenbildung bei wichitgen Daten
; ****** des EEPROMs:				Eeprom_Read_with_Pruefsumme
; *****************************************************************************



; ***********************************************************************
; *****  SCHREIBE ins EEPROM
; WORK ->Adresse wohin geschrieben werden soll
; WORK2 -> WERT

Eeprom_Write:
	EEWrite_Start:				; laut datenblatt warten bis EEPROM bereit 
	sbic	EECONTR, 1			;    if EEWE not clear
	rjmp	EEWrite_Start			;    wait more
	
	out 	EEADRESS, WORK			; setze EEPROM-Adresse auf Adresse
	out	EEDAT, WORK2			; WErt nach DAtenreg.
	sbi	EECONTR, 2			; setze das Daten geschrieben werden sollen
	sbi	EECONTR, 1
	
	EEWrite_End:
	sbic	EECONTR, 1			;    if EEWE not clear
	rjmp	EEWrite_End			;    wait more
	
	;ldi	PAUSEWERT, 50			; vorerst, anstelle bit abfragen
	;rcall	Delay_X
	ret
; *** End ***************************************************************


; ***********************************************************************
; *****  Wichtige Daten aus EEPROM Prfen UND 
; *****  wenn Fehler festgestellt wieder auf Standartwerte setzen 
; *****  welche im Programmspeicher abgelegt sind
; *****  diese mssen nat. an eigene Bedrfniss angepasst werden

Eeprom_Pruef:
	test_AKT_UART_TEILER:
	 ldi	WORK, 	AKT_UART_TEILER		; teste AKT_UART_TEILER
	 rcall	Eeprom_Pruef_Werte		; suche 2 gleiche Werte von 3en
	 tst	TEMP				; Fehler ? >0   (keine 2gleichne gefunden)
	 breq	test_Timer_Aktiv_Byte_Def	; nein dann nchsten Test
	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_FEHLER		   	; TEXT _FEHLER_ ausgeben
	 rcall	Text_progm_To_Disp
 	 ldi	DISPLAY_DAT, 0x20
	 rcall	locateZ_S
	 Text_to_Z Text_BAUD	   		; TEXT _BAUD_ ausgeben  WO ist Fehler..
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
 	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_REP		   	; TEXT _REPARIERE_ ausgeben
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
	 ldi	WORK2, AKT_UART_TEILER_STD	; und EEPROM wieder auf Standart setzen
	 ldi	WORK, AKT_UART_TEILER		; alle drei Speicherstellen
	 rcall	Eeprom_Write
	 ldi	WORK, AKT_UART_TEILER_Pruef1
	 rcall	Eeprom_Write
	 ldi	WORK, AKT_UART_TEILER_Pruef2
	 rcall	Eeprom_Write	
	 rjmp	Init_Reset			; und Reset...
	
	test_Timer_Aktiv_Byte_Def:
 	 ldi	WORK,	Timer_Aktiv_Byte_Def
	 rcall	Eeprom_Pruef_Werte		; suche 2 gleiche Werte von 3en
	 tst	TEMP				; Fehler ? >0
	 breq	test_TASTER_T_Counter_Time	; nein dann nchsten Test
	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_FEHLER		   	; TEXT _FEHLER_ ausgeben
	 rcall	Text_progm_To_Disp
 	 ldi	DISPLAY_DAT, 0x20
	 rcall	locateZ_S
	 Text_to_Z Text_TIMER	   		; TEXT _TIMER_ ausgeben  WO ist Fehler..
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
 	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_REP		   	; TEXT _REPARIERE_ ausgeben
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
	 ldi	WORK2, 	Timer_Aktiv_Byte_Def_STD	; und EEPROM wieder auf Standart setzen
	 ldi	WORK, 	Timer_Aktiv_Byte_Def		; alle drei Speicherstellen
	 rcall	Eeprom_Write
	 ldi	WORK, 	Timer_Aktiv_Byte_Def_Pruef1
	 rcall	Eeprom_Write
	 ldi	WORK, 	Timer_Aktiv_Byte_Def_Pruef2
	 rcall	Eeprom_Write	
	 rjmp	Init_Reset		
	
	test_TASTER_T_Counter_Time:
	 ldi	WORK,	TASTER_T_Counter_Time
	 rcall	Eeprom_Pruef_Werte		; suche 2 gleiche Werte von 3en
	 tst	TEMP				; Fehler ? >0
	 breq	test_eeprom_pruef_end		; nein dann nchsten Test
	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_FEHLER		   	; TEXT _FEHLER_ ausgeben
	 rcall	Text_progm_To_Disp
 	 ldi	DISPLAY_DAT, 0x20
	 rcall	locateZ_S
	 Text_to_Z Text_TAST	   		; TEXT _TASTER_ ausgeben  WO ist Fehler..
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
 	 ldi	DISPLAY_DAT, DISPLAY_CLEAR
	 rcall	Disp_Send_Code
 	 ldi	DISPLAY_DAT, 0x10		; sonst Ausgabe Fehlermeldung 
	 rcall	locateZ_S
	 Text_to_Z Text_REP		   	; TEXT _REPARIERE_ ausgeben
	 rcall	Text_progm_To_Disp
	 ldi	PAUSEWERT, 100
	 rcall	Delay_X_long
	 ldi	WORK2, 	TASTER_T_Counter_Time_STD	; und EEPROM wieder auf Standart setzen
	 ldi	WORK, 	TASTER_T_Counter_Time		; alle drei Speicherstellen
	 rcall	Eeprom_Write
	 ldi	WORK, 	TASTER_T_Counter_Time_Pruef1
	 rcall	Eeprom_Write
	 ldi	WORK, 	TASTER_T_Counter_Time_Pruef2
	 rcall	Eeprom_Write	
	 rjmp	Init_Reset		
	
	test_eeprom_pruef_end:			; kein Fehler
	ret
; ***********************************************************************



; ***********************************************************************
; *****  Daten aus EEPROM lesen und auf 2 gleiche von 3 werten suchen
; ***** noch keine Fehlerbehebung, nur nach 2gleichen suchen
; ***
; *** WORK -> Start Adresse, nachfolgenden ! 2 Bytes werden aus dem EEPROM mit 
; *** Wert verglichen und der Wert zurckgegeben der 2x vorhanden ist...
; *** in jedem Fall wird mindest. der 3te Wert zurckgegeben - 
; ***
; *** der Test ob ein Fehler vorlag mu spter durch TEMP abgfrage erfolgen!
; *** in Eeprom_Pruef
; 
; TEMP -> ungleich Null kennzeichnet das ein Fehler aufgetreten ist..
; WORK2, TEMP,

Eeprom_Pruef_Werte:
	; Ersten wert aus EEPROM lesen
	out 	EEADRESS,  WORK		; setze EEPROM-Adresse auf LeseAdresse 
	sbi	EECONTR,0		; setze das Daten gelsene werden sollen
	in	WORK2, EEDAT		; und schiebe die Daten nach WORK2
	; Zweiten Wert lesen
	inc	WORK			; Adresszeiger erhhen
	out 	EEADRESS,  WORK		; setze EEPROM-Adresse auf LeseAdresse 
	sbi	EECONTR,0		; setze das Daten gelsene werden sollen
	in	TEMP, EEDAT		; und schiebe die Daten nach TEMP
	; Wert 1 = Wert 2 ?
	cp	WORK2, TEMP		; wenn gleich Rckgabe Wert 1 da
	brne	Test1			; 2 gleiche Werte gefunden dann ende
	mov	WORK, WORK2		; gebe Wert zurck
	clr	TEMP			; kennzeichnen kein Fehler aufgetreten fr 
					; Gesamtprfung
	ret				; und Rckgabe 

       Test1:				; sonst weiter testen
	; Dritten Wert lesen
	inc	WORK			; Adresszeiger auf dritte Adresse
	out 	EEADRESS,  WORK		; setze EEPROM-Adresse auf LeseAdresse 
	sbi	EECONTR,0		; setze das Daten gelsene werden sollen
	in	WORK, EEDAT		; WORK kann jetzt berschrieben werden, Adr. nicht mehr bent.
	; Wert 1 = Wert 3
	cp	WORK2, WORK
	brne	Test2
					; richtige Wert schon in WORK
	clr	TEMP			; noch keine Schwerwiegender Fehler da 2 gleiche Werte gefunden
	ret				; als Zeichen dafr 0 zurckgeben 

       Test2:
	; Wert 2 = Wert 3 ?
	cp	TEMP, WORK
	brne	fail_eeprom		; fehler, keine 2 gleichen Werte
					; richtige Wert schon in WORK
	clr	TEMP			; noch keine Schwerwiegender Fehler da 2 gleiche Werte gefunden
	ret				; als Zeichen dafr 0 zurckgeben 
	
       fail_eeprom:
	ldi	TEMP, 0x01		; grer Null kenzeichnet das Schwerwieg. EEPROM-Fehler
	ret
; *** End ***************************************************************