; ***********************************************************************
; *** Die Routinen zum senden und empfangen mit dem internen UART 
; *** inclusive der Apspeicherung der Daten in den Puffer und 
; *** ausfiltern von 'von vornherein' ungltigen Zeichen 
; *** 							UART_RX_C
; *** UND
; *** das Auslesen von Daten aus dem PUFFER
; *** 							READ_PUFFER



; *********************************************************************
; **** UART ***********************************************************
; **** Interuptbehandlung nachdem ein Zeichen empfangen ***************
; **** in Puffer speichern u.CTS/XOFF entspr. setzen, w Puffer voll ***
; **** puffert nur ASC(32-126) !!! ************************************            
; ***** -- Register ***************************************************
; ***** Allg.				: WORK_UART *( ab r16)*********
; ***** schreiben in RAM                :       r28,r29 Y_L,Y_H *******
; ***** Pufferposisition und Gre	: 2x unter r16 ****************
; ***** zwischenspeicher		: 	TEMP *(ab r16)*********
; *****                                      in Stack gesichert !******
; ***** zwischenspeicher		: 	WORK *(ab r16)*********
; *****                                      in Stack gesichert !******
; ***** -- Routinen ***************************************************
; ***** DD-RAM ADresse an Display	:	Disp_Send_Code ********
; *********************************************************************
UART_RX_C:
	in	SAVE_STATUS_FLAG,STATUS_FLAG	; Rette StatusRegister da es verndert wird !!
					; teste ob es ein Fehler war der Empfangen wurde
	in	WORK_UART,UART_UCSRA	; Status einlesen
	sbrs	WORK_UART,4		; wenn bit=1 dann ein FramError u. 'jmp Read'
	rjmp	SAVE_CHAR		; wird berspr. , wenn kein Fehler ab zu Zeichen lesen
	in 	WORK_UART,UART_UDR	; nur wenn FrameError, UDR mu gelesen werden damit IRQ frei wird
	reti				; EXIT
    SAVE_CHAR:				; Zeichen einlesen u. in Puffer speichern
  	in 	WORK_UART,UART_UDR	; lese UDR - Zeichen, gib int frei
	; Code Zeichen ~ wird auch gepuffert, sonst ->
	; was war es fr Zeichen ? nur Zeichen 32-127 wird gepuffert !!!!
	; wenn // usw. bentigt, dann noch anpassen !!!!!!!!!!!!!!!!!!
	cpi	WORK_UART,ASC_CODE      ; Code einleitungszeichen ?
	breq	SAVE_C
	cpi	WORK_UART, ASC_UG	; Zeichen ab SPACE speichern in Puffer
	brlo	End_UART_RX
	cpi	WORK_UART, ASC_OG	; obere Grenze fr Zeichen die gesp. werden
	brsh	End_UART_RX
	; und weiter mit speichern in SRAM (Puffer)
    SAVE_C:
  	mov	Y_L,PUFFER_POS		; Akt. Pufferpos. lesen
  	clr	Y_H			
  	st	Y+,WORK_UART		; schreibe Zeichen in Puffer(SRAM) an entsp. Posit.
	mov	PUFFER_POS,Y_L
	inc	PUFFER_AKT_LAENG	; akt. PufferLnge = PufferLnge + 1
	ldi	Y_H, PUFFER_LAENGE_GESAMT-PUFFER_LAENGE_RESERVE  ; Schutz vor berlauf
	cp	PUFFER_AKT_LAENG,Y_H	; PUFFER_LAENGE  auf Puffer Voll ?
	brlt	End_UART_RX		; dann CTS / od. XOFF aktiv machen sonst P_berlauf	
	
	tst	UART_FLUSS_REG		; wird CTS oder XON verwendet ?
	breq	NO_SOFTWARE_FLUSS_2
	ldi	WORK_UART,19
	out	UART_UDR, WORK_UART	; XOFF senden
	rjmp	TEST_FLUSS_END_2
	NO_SOFTWARE_FLUSS_2:
	sbi	PORTD_DDR,2  		; Port_D-CTS auf Ausgabe
	sbi	PORTD_D,2		; und CTS aktiv damit keine Daten mehr kommen
	TEST_FLUSS_END_2:
		
	ldi	Y_H, PUFFER_LAENGE_GESAMT+1  ; BUFFERBERLAUF doch passiert ?
	cp	PUFFER_AKT_LAENG,Y_H	
	brlo	End_UART_RX		; dann RESET
	rcall	Init_Reset
    End_UART_RX:		
    	out	STATUS_FLAG,SAVE_STATUS_FLAG ; und Flags in orig. zustand
	reti
; *** End UART_RX_C ***************************************************


; *********************************************************************
; **** zeichen aus Puffer lesen und Puffer-Zeiger enstpr. Posit. ******
; **** und CTS/XOFF entspr. setzen, falls an war **********************
; ***** -- Register ***************************************************
; ***** Ausgabe des gelesenen Wertes	:	DISPLAY_DAT *( ab r16)*
; ***** Lesen aus RAM                   :       r30,r31 Z_L,Z_H *******
; ***** Pufferposisition und Gre	: 2x unter r16 ****************
; ***** zwischenspeicher		: 	TEMP *(ab r16)*********
; *****                                      in Stack gesichert !******
; ***** zwischenspeicher		: 	WORK *(ab r16)*********
; *****                                      in Stack gesichert !******
; ***** -- Routinen ***************************************************
; ***** DD-RAM ADresse an Display	:	Disp_Send_Code ********
; *********************************************************************
READ_PUFFER:	
	push	TEMP			; 
    	push	WORK
	push	Z_L

	ldi	Z_L,UART_CR_OFF		; UART - Einstellen das kein Int 
	out	UART_UCSRB,Z_L		; beim auslesen ausgelst wird
	tst	PUFFER_AKT_LAENG	; Puffer leer ? also lange null
	breq	End_leer		; dann ende
    	ldi	Z_L,PUFFER		; 1.Zeichen aus Puffer lesen
    	clr	Z_H			; aus SRAM 
    	ld	DISPLAY_DAT, Z		; und nach DISPLAY_DAT     (vorerst!-evt. extraReg.)
	mov	WORK, PUFFER_AKT_LAENG	; sichern
	dec	WORK
    	dec	PUFFER_AKT_LAENG	; Pufferlnge minus 1
	breq	End_jetzt_leer		; ist lnge jetzt 0 ? (also puffer leer) 
   READ_Loop:				; Puffer schieben (spter evt. andere Art)
   	ldd	TEMP, Z+1		; lese nchstes Zeichen
   	st	Z+, TEMP
   	dec	WORK
   	brne	READ_Loop
    End_jetzt_leer:
    	clr	TEMP
    	st	Z, TEMP			; 1.Zeichen lschen
  	mov	PUFFER_POS,Z_L
    End_leer:    
	mov	WORK, PUFFER_AKT_LAENG	; mache Puffer erstmal etwas leer bevor CTS frei wird
	cpi	WORK, 2			; 
	brge	End_E			; 
	; mu ERST dafor angeschalten werden, sont evt berlappungen I/O
	ldi	Z_L,UART_CR		; Betriebsart des UART auf AN
	out	UART_UCSRB,Z_L

	tst	UART_FLUSS_REG		; wird CTS oder XON verwendet ?
	breq	NO_SOFTWARE_FLUSS_3
    	ldi 	WORK, 17		; XON
	out 	UART_UDR,WORK
	rjmp	TEST_FLUSS_END_3
	NO_SOFTWARE_FLUSS_3:
	sbi	PORTD_DDR,2		; ansonsten cts aus
	cbi	PORTD_D,2		; damit neue Zeichnen kommen knnen
	TEST_FLUSS_END_3:

    End_E:
   	ldi	Z_L,UART_CR		; Betriebsart des UART auf AN
	out	UART_UCSRB,Z_L

	pop	Z_L
	pop 	WORK  	
    	pop 	TEMP
	ret
; *** End Read_Puffer**************************************************
